Sliding Window Maximum | LeetCode

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

For example,
Given nums = [1,3,-1,-3,5,3,6,7], and k = 3.

Window position                Max
---------------               -----
[1  3  -1] -3  5  3  6  7       3
 1 [3  -1  -3] 5  3  6  7       3
 1  3 [-1  -3  5] 3  6  7       5
 1  3  -1 [-3  5  3] 6  7       5
 1  3  -1  -3 [5  3  6] 7       6
 1  3  -1  -3  5 [3  6  7]      7

Therefore, return the max sliding window as [3,3,5,5,6,7].

Note: 
You may assume k is always valid, ie: 1 ≤ k ≤ input array's size for non-empty array.

Follow up:
Could you solve it in linear time?


如果你对STL熟悉的话,可以很偷懒的完成这道题。我们其实只需保证我们设计的数据结构始终有序即可,可以自己实现一个二叉搜索树。一个更简单的方法是直接利用STL的multiset。 set和map中的key元素均是排好序的。所以我们只需要以此把元素压入set中,并且以此返回头元素即可。
注意几点:
1. 这里需要用multiset而不是set,因为可能会有重复元素
2. set默认的排序是把最小的key排在前面,我们可以利用模板set>的方法来改变排序方式,如果想自己定义排序函数,可以参考之前的priority_queue。
3. 当需要取最大的元素时,直接对set.begin()取内容即可

代码如下,很简单
class Solution {
public:
    vector maxSlidingWindow(vector& nums, int k) {
        vector result;
        if (nums.empty())
            return result;
            
        multiset> que;
        for (int i = 0; i < k; i++)
            que.insert(nums[i]);
        result.push_back(*que.begin());
        for (int shift = 1; shift <= nums.size() - k; shift++) {
            que.erase(que.find(nums[shift-1]));
            que.insert(nums[k+shift-1]);
            result.push_back(*que.begin());
        }
        return result;
    }
};



你可能感兴趣的:(Sliding Window Maximum | LeetCode)